/**
 * 
 */
package mk.com.java.demos.threads.gui;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

import mk.com.java.demos.threads.CounterThread;

/**
 * @author Igor Savic
 * @date 11.01.2010
 */
public class MainScreen extends JFrame implements MouseListener {

	private static final int MAX_ITERATIONS_COUNT = 10;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private List<Thread> threads = new ArrayList<Thread>();

	private JButton buttonStartThread = null;
	
	public MainScreen() {
        initComponents();
    }

    private void initComponents() {
    	setTitle("Java GUI & Threads od Igor Savic za Java.com.mk");
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);        
        getContentPane().setLayout(null);   
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-500)/2, (screenSize.height-300)/2, 500, 300);
        setVisible(true);
        
        buttonStartThread = new JButton();
        buttonStartThread.setText("STARTUVAJ NOV THREAD");
        buttonStartThread.setLocation(300, 0);
        buttonStartThread.setSize(180, 25);
        buttonStartThread.addMouseListener(this);
        getContentPane().add(buttonStartThread);
    }
	
    private void initNewThread(){
    	JLabel lblDummy;
    	lblDummy = new javax.swing.JLabel();
        lblDummy.setLocation(0,threads.size() * 20);
        lblDummy.setSize(400, 20);
        getContentPane().add(lblDummy);
        
        CounterThread counterThread = new CounterThread(lblDummy, MAX_ITERATIONS_COUNT);
        Thread thread = new Thread(counterThread);
        counterThread.setThreadId(thread.getId());
        threads.add(thread);
        thread.start();
    }

    @Override
	public void mousePressed(MouseEvent e) {
			initNewThread();
	}
    
	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

}
